# This script can be used to calculate speciation plots which include ALL possible minerals.
# This is done in two main steps: the first step calculates the list of all 
# possible minerals and writes this to the tag dictionary as <allmin>. That is what this file does.

# The second part is to include the <allmin> tag containing the list of mineral species in an EQUILIBRIUM_PHASES 
# data block in a 'species' calculationType which uses e.g. logspeciesvsph.inc.
# See \demo\Cdspeciation_log\Cdspeciation_logspecies_including_allmin.ppi

# This combination enables a plot to be produced which will select any precipitated minerals from 
# the minerals found in the used database.

# Caveat emptor!

PRINT
  -reset true #

PHASES
Fix_H+
   H+ = H+
   log_k 0.0
   
SELECTED_OUTPUT 1
   -high_precision true
   -reset false #
   
USER_PUNCH 1
-headings allmin
-start

10 REM Make a single tag of all mineral phase names so that they can be included in the next simulation
20 s$ = ''
30 REM Get a list of possible minerals

40 simax = SYS("phases", np, np$, tp$, sis)

100 FOR i = 1 TO np
110    IF(ABS(sis(i)) < -1e-11) THEN 150
120    IF(INSTR(np$(i), "(g)") > 0 OR INSTR(np$(i), "Fix") > 0) THEN 150  # filter out gases and virtual phases
130    s$ = s$ + TRIM(np$(i)) + " 0 0" + CHR$(59)       # e.g. Fe(OH)3(a) 0 0... CHR$(59) is a semi-colon
140 REM PRINT i, TRIM(np$(i)), sis(i)
150 NEXT i

160 REM PRINT "allmin = ", s$
170 PUNCH s$    # send it

200 END

