# Used by ht1 and grid calculations to calculate a predominance diagram based on the 'predominance' criterion.
# The water and methane constraints have been omitted so they will not appear in the diagram.
PRINT
   -reset false
PHASES
Fix_H+
   H+ = H+
   log_k 0.0
SELECTED_OUTPUT 1
   -high_precision true
   -reset false
USER_PUNCH 1
-headings
-start
1 small = 1e-12
20 nout1 = 0
40 nout3 = 0
50 main$ = "<mainspecies>"
60 IF (STEP_NO = 0) THEN 370 ELSE 70
70 totel = SYS(main$, n, n$, t$, moles)
80 h2o = TOT("water")

90 REM Predominant species based on concn (but filter out gases)
100 REM species are sorted largest first
100 FOR i = 1 TO n
110   IF (moles(i) <= small) THEN 190
120   REM IF (t$(i) <> 'aq') THEN 180   # uncomment if only want aq species
130   IF (INSTR(n$(i), "(g)") > 0) THEN 180
140   PUNCH n$(i), moles(i)/h2o
150 REM PRINT i, n$(i), moles(i)/h2o
160   nout1 = nout1+1
170   IF (nout1 >= 3) THEN 190
180 NEXT i

190 REM no forced mineral species (see ht1stability.inc)
191 nout2 = 0


290 REM add any extra 'carry' variables for viewing using name, value pairs as above
299 nout4 = 0

300 REM the 5 system variables (always required)
301 po2 = SI("O2(g)")
310 ph2 = SI("H2(g)")
320 ph = -LA("H+")
330 pe = -LA("e-")
340 PUNCH "pH", ph, "pe", pe, "PO2", po2, "PH2", ph2, "temp", TC
350 nout5 = 5

360 REM output the 5 counters
361 PUNCH nout1, nout2, nout3, nout4, nout5
370 END

