PRINT
  -reset false

SELECTED_OUTPUT
  -high_precision       true
  -reset                false

# Used to generate data for a %species vs pH plot.
# The 'mainSpecies' keyword in the input file is used to set the main species (sets the "<mainspecies>" tag).
# Writes successive 'species names-value' pairs to the 'out' file.
# These are plotted with a custom plot.
# The species always starts with the x-axis variable (here pH) then all the other main component
# species in descending abundance order returning log10(concns) for all species.
# line 50 filters out H and O species.

# includes 'total dissolved species' in plot

#
# The input file
# ==============
# "<mainspecies>" must be set to the 'element' of interest, or "elements" for counting at the 'elements' level.
# 'customXcolumn' must be set to the column where the pH is written, as here in column 2
#
USER_PUNCH
  -start
1 small = 1e-12
10 main$ = "<mainspecies>"
20 PUNCH "pH", -LA("H+")
30 totel = SYS(main$, n, n$, t$, moles)
35 totw = TOT("water")

40 FOR i = 1 TO n
50   IF(MID$(n$(i), 1, 2) = "H(" OR MID$(n$(i), 1, 2) = "O(" OR n$(i) = "O" OR n$(i) = "H") THEN 100
55   IF (moles(i)>small AND totw>0) THEN 60 ELSE 97
60   IF(t$(i) = "equi") THEN 70 ELSE 90
70   IF (instr(n$(i),"(g)")=0) THEN PUNCH n$(i)+"(s)", LOG10(moles(i)/totw) ELSE PUNCH n$(i), LOG10(moles(i)/totw)
80   GOTO 100
90   PUNCH n$(i), LOG10(moles(i)/totw)
95   GOTO 100
96   REM -99999 is PhreePlot UNDEFINED value
97   PUNCH n$(i)+"(s)", -99999
100 NEXT i

110 IF  (TOT("<mainspecies>")>0) THEN PUNCH "<mainspecies>(tot. diss)", LOG10(TOT("<mainspecies>")) ELSE PUNCH "<mainspecies>(tot. diss)", -99999

