PRINT
  -reset false

SELECTED_OUTPUT
  -high_precision       true
  -reset                false

# Used to generate data for a %species vs pH plot.
# The 'mainSpecies' keyword in the input file is used to set the main species (sets the "<mainspecies>" tag).
# This version accepts 'all' as a main species and will plot all species of all elements.
# Writes successive 'species names-value' pairs to the 'out' file.
# These are plotted with a custom plot.
# The species always starts with the x-axis variable (here pH) then all the other main component
# species in descending abundance order returning relative amounts (% of total) for each species.
# Line 50 filters out H and O species; modify this to filter out other unwanted species.
#
# The input file
# ==============
# "<mainspecies>" must be set to the 'element' of interest, or "elements" for counting at the 'elements' level.
# 'customXcolumn' must be set to the column where the pH is written, as here in column 2
#
USER_PUNCH
  -start  

1 DIM nel$(1)
2 nel$(1) = "<mainspecies>"
3 nel = 1
4 DIM found$(1000)
5 nfound = 0
6 if (nel$(1) <> "all") THEN 15

12 totel = SYS("elements", nel, nel$, tel$, molesel)
13 PRINT 

15 FOR k = 1 TO nel

16   main$ = nel$(k)

20   IF (k = 1) THEN PUNCH "pH", -LA("H+")
30   totel = SYS(main$, n, n$, t$, moles)
35   IF (totel <=0) THEN 110

40   FOR i = 1 TO n
50     IF(MID$(n$(i), 1, 4) = "H(0)" OR MID$(n$(i), 1, 4) = "O(0)" OR n$(i) = "O" OR n$(i) = "H") THEN 100
60     IF(t$(i) = "equi") THEN 70 ELSE 85
70     IF (instr(n$(i),"(g)")=0) THEN PUNCH n$(i)+"(s)", 100*moles(i)/totel ELSE PUNCH n$(i), 100*moles(i)/totel
80     GOTO 100
85     GOSUB 1000
90     IF (isfound = 1) THEN PUNCH n$(i), 100*moles(i)/totel
100  NEXT i

110 NEXT k

120 END

1000 isfound = 0
1010 FOR icheck = 1 to nfound
1020   if (n$(i) = found$(icheck)) THEN 1100
1030 NEXT icheck
1040 REM not found so add it
1050 nfound = nfound + 1
1060 found$(nfound) = n$(i)
1070 isfound = 1
1100 RETURN


